(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     20100,        492]
NotebookOptionsPosition[     18633,        460]
NotebookOutlinePosition[     18973,        475]
CellTagsIndexPosition[     18930,        472]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{
  "(*", "***********************************************************************)"}\
], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "file", " ", "was", " ", "generated", " ", "automatically", 
    " ", "by", " ", "the", " ", "Mathematica", " ", "front", " ", 
    RowBox[{"end", "."}]}], "  ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "It", " ", "contains", " ", "Initialization", " ", "cells", " ", "from", 
     " ", "a", " ", "Notebook", " ", "file"}], ",", " ", "which"}], 
   "         ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "typically", " ", "will", " ", "have", " ", "the", " ", "same", " ", 
    "name", " ", "as", " ", "this", " ", "file", " ", "except", " ", "ending",
     " ", "in"}], "      ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"\"\<.nb\>\"", " ", "instead", " ", "of", " ", 
    RowBox[{"\"\<.m\>\"", "."}]}], 
   "                                               ", "*)"}], "\n", 
  RowBox[{
  "(*", "                                                                     \
 ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "This", " ", "file", " ", "is", " ", "intended", " ", "to", " ", "be", " ",
     "loaded", " ", "into", " ", "the", " ", "Mathematica", " ", "kernel", 
    " ", "using"}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "the", " ", "package", " ", "loading", " ", "commands", " ", "Get", " ", 
    "or", " ", 
    RowBox[{"Needs", ".", "  ", "Doing"}], " ", "so", " ", "is", " ", 
    "equivalent"}], "   ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "to", " ", "using", " ", "the", " ", "Evaluate", " ", "Initialization", 
    " ", "Cells", " ", "menu", " ", "command", " ", "in", " ", "the", " ", 
    "front"}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"end", "."}], 
   "                                                                 ", 
   "*)"}], "\n", 
  RowBox[{
  "(*", "                                                                     \
 ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"DO", " ", "NOT", " ", "EDIT", " ", "THIS", " ", 
    RowBox[{"FILE", ".", "  ", "This"}], " ", "entire", " ", "file", " ", 
    "is", " ", "regenerated"}], "              ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{
   "automatically", " ", "each", " ", "time", " ", "the", " ", "parent", " ", 
    "Notebook", " ", "file", " ", "is", " ", "saved", " ", "in", " ", "the"}],
    "     ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"Mathematica", " ", "front", " ", 
    RowBox[{"end", ".", "  ", "Any"}], " ", "changes", " ", "you", " ", 
    "make", " ", "to", " ", "this", " ", "file", " ", "will", " ", "be"}], 
   "    ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{"overwritten", "."}], 
   "                                                         ", "*)"}], "\n", 
  RowBox[{
  "(*", "***********************************************************************)"}\
], "\n"}]], "Code",ExpressionUUID->"8c1c4c4c-0fd0-4f5f-b6e0-b6ccd70aa058"],

Cell[CellGroupData[{

Cell["Begin Package", "Subsection",ExpressionUUID->"7bad79f7-9ec2-492c-908e-80f0565b992a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<AdiabaticTools`\>\"", ",", "\n", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Global`\>\"", ",", "\n", "\"\<SpinDynamica`\>\"", ",", "\n", 
      "\"\<QM`Hilbert`\>\"", ",", "\n", "\"\<QM`SpinOperators`\>\"", ",", 
      "\n", "\"\<QM`Liouville`\>\"", ",", "\n", 
      "\"\<SD`CorrelatedEigensystems`\>\""}], "}"}]}], "\n", "]"}], 
  ";"}]], "Code",ExpressionUUID->"e44b61fd-9a75-4490-bb8d-d8e45028e0c3"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "usage"}], " ", "=", " ", 
   "\"\<The function \\!\\(\\*\n\
StyleBox[\\\"adiabaticprofile\\\",\\nFontSlant->\\\"Italic\\\"]\\) generates \
and adiabatic profile in agreement with the constant adiabaticity approach \
described in: https://doi.org/10.1063/1.5079436.\n\nThe syntax for \\!\\(\\*\n\
StyleBox[\\\"adiabaticprofile\\\",\\nFontSlant->\\\"Italic\\\"]\\) is given \
by: adiabaticprofile[{\\!\\(\\*SubscriptBox[\\(H\\), \\(0\\)]\\), \
\\!\\(\\*SubscriptBox[\\(Q\\), \\(ad\\)]\\)}, {x, \
\\!\\(\\*SubscriptBox[\\(x\\), \\(min\\)]\\), \\!\\(\\*SubscriptBox[\\(x\\), \
\\(max\\)]\\), \[Delta]x}, {\\!\\(\\*SubscriptBox[\\(\[Xi]\\), \
\\(target\\)]\\), adiabatic_states}].\n\n*) \\!\\(\\*SubscriptBox[\\(H\\), \
\\(0\\)]\\) represents the time-independent part of the Hamiltonian.\n*) \
\\!\\(\\*SubscriptBox[\\(Q\\), \\(ad\\)]\\) represents the adiabatic \
generator.\n\n*) x represents the adiabatic coordinate.\n*) \
\\!\\(\\*SubscriptBox[\\(x\\), \\(min\\)]\\), \\!\\(\\*SubscriptBox[\\(x\\), \
\\(max\\)]\\) and \[Delta]x represent the initial value, the final value and \
the increment of the adiabatic coordinate, respectively.\n\n*) \
\\!\\(\\*SubscriptBox[\\(\[Xi]\\), \\(target\\)]\\) represents the target \
adiabaticity parameter such that \[Xi](t) = \
\\!\\(\\*SubscriptBox[\\(\[Xi]\\), \\(target\\)]\\) \[ForAll] t \
\[GreaterEqual] 0. The target adiabaticity \\!\\(\\*SubscriptBox[\\(\[Xi]\\), \
\\(target\\)]\\) usually stretches or contracts the time-axis.\n*) \
adiabatic_states represents the set of adiabatic states that should be \
included in the calculation of the generalised adiabaticity parameter. \
Relevant adiabatic states may be determined by considering the eigenvalues \
returned by CorrelatedEigensystems, for example.\n\nFor a typical SLIC \
experiment with Hamiltonian:  \n\nH(\\!\\(\\*SubscriptBox[\\(\[Nu]\\), \
\\(x\\)]\\)) = J opI[1].opI[2] + \[CapitalDelta]/2 (opI[1,z]-opI[2,z]) + \
\\!\\(\\*SubscriptBox[\\(\[Nu]\\), \\(x\\)]\\) opI[x],\n\nthe adiabatic \
profile with constant adiabaticity parameter would be calculated as follows:\n\
\nadiabaticprofile[{50 opI[1].opI[2] + 10/2 (opI[1,z]-opI[2,z]), opI[x]}, \
{\\!\\(\\*SubscriptBox[\\(\[Nu]\\), \\(x\\)]\\), 0, 100, 1}, {.5, {1,4}}]\n\n\
The output generated by \\!\\(\\*\n\
StyleBox[\\\"adiabaticprofile\\\",\\nFontSlant->\\\"Italic\\\"]\\) takes the \
form {{evsystem,evecsystem},{\\!\\(\\*SubscriptBox[\\(t\\), \\(max\\)]\\), \
f[t]}}. \n\n*) evsystem is a system of correlated eigenvalues as returned by \
CorrelatedEigensystems.\n*) evecsystem is a system of correlated eigenvectors \
as returned by CorrelatedEigensystems.\n\n*) \\!\\(\\*SubscriptBox[\\(t\\), \
\\(max\\)]\\) is the time it takes the constant adiabaticity sweep to reach \
\\!\\(\\*SubscriptBox[\\(x\\), \\(max\\)]\\).\n*) f[t] is the corresponding \
adiabatic profile with constant adiabaticity \
\\!\\(\\*SubscriptBox[\\(\[Xi]\\), \\(target\\)]\\).\>\""}], ";"}]], "Code",Ex\
pressionUUID->"4b5fb34a-06b8-4c11-ace2-bc69f3adc49a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Code",ExpressionU\
UID->"b3fc93cb-6c11-4a69-9bef-e1a189a21b94"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Input checks", "Subsection",ExpressionUUID->"bf2db097-81e9-41b0-bc23-271763efbf46"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "HnotQ"}], "=", " ", 
   "\"\<The Hamiltonian is not an operator\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "QnotQ"}], "=", " ", 
   "\"\<The adiabatic generator is not an operator\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "xdef"}], "=", " ", 
   "\"\<The adiabatic coordinate is not undefined\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "xmindef"}], "=", " ", 
   "\"\<The initial value for the adiabatic coordinate is not a number\>\""}],
   ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "xmaxdef"}], "=", "  ", 
   "\"\<The final value for the adiabatic coordinate is not a number\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "dxdef"}], "=", "  ", 
   "\"\<The increment for the adiabatic coordinate is not a number\>\""}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "\[Xi]def"}], "=", "  ", 
   "\"\<The target adiabaticity parameter is not a number\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "::", "statesdef"}], "=", "  ", 
   "\"\<The set of adiabatic states is not a list of integers\>\""}], 
  ";"}]}], "Code",ExpressionUUID->"dedd253e-913a-4d91-93dc-d35e64f8ce92"]
}, Open  ]],

Cell[CellGroupData[{

Cell["main function", "Subsection",ExpressionUUID->"8b55d452-3b3e-4912-b1c6-876166bb952e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"adiabaticprofile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"H0_", ",", "Qtd_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "xmin_", ",", "xmax_", ",", "dx_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Xi]0_", ",", "states_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Qtdmat", ",", "Hmat", ",", "\[CapitalSigma]system", ",", 
       "\[CapitalLambda]system", ",", "evraw", ",", "\[Omega]ij", ",", 
       "Qtdin\[CapitalLambda]", ",", "Qij", ",", "indexset", ",", "\[Xi]", 
       ",", "qtd", ",", "qprofile", ",", "tmax"}], "}"}], ",", "\n", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OperatorQ", "[", "H0", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "HnotQ"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"OperatorQ", "[", "Qtd", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "QnotQ"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"UnassignedSymbols", "[", "x", "]"}], "]"}], "==", "1"}], 
        ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "xdef"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"NumberQ", "[", "xmin", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "xmindef"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"NumberQ", "[", "xmax", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "xmaxdef"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"NumberQ", "[", "dx", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "dxdef"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"NumberQ", "[", "\[Xi]0", "]"}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "\[Xi]def"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"Quiet", "@", 
         RowBox[{"MatchQ", "[", 
          RowBox[{
           RowBox[{"Union", "[", 
            RowBox[{"IntegerQ", "/@", "states"}], "]"}], ",", 
           RowBox[{"{", "True", "}"}]}], "]"}]}], ",", " ", "True", ",", " ", 
        RowBox[{
         RowBox[{"Message", "[", 
          RowBox[{"adiabaticprofile", "::", "statesdef"}], "]"}], ";", 
         RowBox[{"Abort", "[", "]"}]}]}], "]"}], ";", "\n", 
      RowBox[{"Hmat", "=", 
       RowBox[{"MatrixRepresentation", "[", 
        RowBox[{"H0", "+", 
         RowBox[{"x", " ", "Qtd"}]}], "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalSigma]system", ",", "\[CapitalLambda]system"}], 
        "}"}], "=", 
       RowBox[{"CorrelatedEigensystems", "[", 
        RowBox[{"Hmat", ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "xmin", ",", 
           RowBox[{
            RowBox[{"5", "*", "dx"}], "+", "xmax"}], ",", "dx"}], "}"}]}], 
        "]"}]}], ";", "\n", 
      RowBox[{"evraw", "=", 
       RowBox[{
        RowBox[{"Transpose", "[", "\[CapitalSigma]system", "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "All", ",", "2"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"\[Omega]ij", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i_", ",", "j_"}], "}"}], ",", "k_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"evraw", "[", 
         RowBox[{"[", 
          RowBox[{"k", ",", "i"}], "]"}], "]"}], "-", 
        RowBox[{"evraw", "[", 
         RowBox[{"[", 
          RowBox[{"k", ",", "j"}], "]"}], "]"}]}]}], ";", "\n", 
      RowBox[{"Qtdmat", "=", 
       RowBox[{"MatrixRepresentation", "[", "Qtd", "]"}]}], ";", "\n", 
      RowBox[{"Qtdin\[CapitalLambda]", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"#", ".", "Qtdmat", ".", 
          RowBox[{"ConjugateTranspose", "[", "#", "]"}]}], "&"}], "/@", 
        RowBox[{"\[CapitalLambda]system", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], ";", "\n", 
      RowBox[{
       RowBox[{"Qij", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"i_", ",", "j_"}], "}"}], ",", "k_"}], "]"}], ":=", 
       RowBox[{
        RowBox[{"Qtdin\[CapitalLambda]", "[", 
         RowBox[{"[", "k", "]"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ";", "\n", 
      RowBox[{"indexset", "=", 
       RowBox[{
        RowBox[{"Flatten", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"i", ",", "j"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "states"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"j", ",", "states"}], "}"}]}], "]"}], ",", "1"}], "]"}], 
        "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"i_", ",", "i_"}], "}"}], ":>", " ", "Nothing"}], 
         "}"}]}]}], ";", "\n", 
      RowBox[{
       RowBox[{"\[Xi]", "[", "xint_", "]"}], ":=", 
       RowBox[{"Evaluate", "[", "\n", 
        RowBox[{
         RowBox[{"Interpolation", "[", "\n", 
          RowBox[{"Transpose", "[", "\n", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\[CapitalLambda]system", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Sqrt", "[", 
                RowBox[{"Sum", "[", 
                 RowBox[{
                  RowBox[{"If", "[", 
                   RowBox[{
                    RowBox[{"MatchQ", "[", 
                    RowBox[{
                    RowBox[{"Chop", "[", 
                    RowBox[{"\[Omega]ij", "[", 
                    RowBox[{"ij", ",", "#"}], "]"}], "]"}], ",", "0"}], "]"}],
                     ",", "0", ",", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"Qij", "[", 
                    RowBox[{"ij", ",", "#"}], "]"}], "^", "2"}], "/", 
                    RowBox[{
                    RowBox[{"\[Omega]ij", "[", 
                    RowBox[{"ij", ",", "#"}], "]"}], "^", "4"}]}], ")"}]}], 
                   "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"ij", ",", "indexset"}], "}"}]}], "]"}], "]"}], 
               "&"}], "/@", 
              RowBox[{"Range", "[", 
               RowBox[{"1", ",", 
                RowBox[{"Length", "[", "\[CapitalLambda]system", "]"}]}], 
               "]"}]}]}], "}"}], "\n", "]"}], "\n", "]"}], "[", "xint", "]"}],
         "\n", "]"}]}], ";", "\n", 
      RowBox[{"qprofile", "=", 
       RowBox[{"qtd", "/.", 
        RowBox[{"First", "@", 
         RowBox[{"Quiet", "@", 
          RowBox[{"NDSolve", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"qtd", "'"}], "[", "t", "]"}], "==", 
               RowBox[{"\[Xi]0", "*", 
                RowBox[{"1", "/", 
                 RowBox[{"\[Xi]", "[", 
                  RowBox[{"qtd", "[", "t", "]"}], "]"}]}]}]}], ",", 
              RowBox[{
               RowBox[{"qtd", "[", "0", "]"}], "==", "xmin"}], ",", 
              RowBox[{"WhenEvent", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"qtd", "[", "t", "]"}], "==", "xmax"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"tmax", "=", "t"}], ",", 
                  "\"\<StopIntegration\>\""}], "}"}]}], "]"}]}], "}"}], ",", 
            "qtd", ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "0", ",", "\[Infinity]"}], "}"}]}], 
           "]"}]}]}]}]}], ";", "\n", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[CapitalSigma]system", ",", "\[CapitalLambda]system"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"tmax", ",", "qprofile"}], "}"}]}], "}"}]}]}], "\n", "]"}]}],
   ";"}]], "Code",ExpressionUUID->"fc829dc9-5d4c-4d91-bd4e-de3c822d46a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Subsection",ExpressionUUID->"09a49370-ccc1-4e49-9800-fb7c4f15c464"],

Cell[BoxData[
 RowBox[{
  RowBox[{
  "Print", "[", "\"\<SpinDynamica constant adiabaticity addon 1.0\>\"", "]"}],
   ";"}]], "Code",ExpressionUUID->"80688092-0d1b-43b2-aafc-633228597fcb"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Code",ExpressionUUID->"4eece4ae-\
ebe4-4075-af94-ec70a14f0ae5"]
}, Open  ]]
},
WindowSize->{775, 872},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
FrontEndVersion->"12.0 for Microsoft Windows (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 3037, 70, 340, "Code",ExpressionUUID->"8c1c4c4c-0fd0-4f5f-b6e0-b6ccd70aa058"],
Cell[CellGroupData[{
Cell[3620, 94, 90, 0, 53, "Subsection",ExpressionUUID->"7bad79f7-9ec2-492c-908e-80f0565b992a"],
Cell[3713, 96, 475, 10, 169, "Code",ExpressionUUID->"e44b61fd-9a75-4490-bb8d-d8e45028e0c3"],
Cell[4191, 108, 3075, 45, 606, "Code",ExpressionUUID->"4b5fb34a-06b8-4c11-ace2-bc69f3adc49a"],
Cell[7269, 155, 148, 3, 70, "Code",ExpressionUUID->"b3fc93cb-6c11-4a69-9bef-e1a189a21b94"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7454, 163, 89, 0, 70, "Subsection",ExpressionUUID->"bf2db097-81e9-41b0-bc23-271763efbf46"],
Cell[7546, 165, 1385, 36, 70, "Code",ExpressionUUID->"dedd253e-913a-4d91-93dc-d35e64f8ce92"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8968, 206, 90, 0, 70, "Subsection",ExpressionUUID->"8b55d452-3b3e-4912-b1c6-876166bb952e"],
Cell[9061, 208, 9051, 231, 70, "Code",ExpressionUUID->"fc829dc9-5d4c-4d91-bd4e-de3c822d46a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18149, 444, 88, 0, 70, "Subsection",ExpressionUUID->"09a49370-ccc1-4e49-9800-fb7c4f15c464"],
Cell[18240, 446, 187, 4, 70, "Code",ExpressionUUID->"80688092-0d1b-43b2-aafc-633228597fcb"],
Cell[18430, 452, 187, 5, 70, "Code",ExpressionUUID->"4eece4ae-ebe4-4075-af94-ec70a14f0ae5"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

